// library with Conflux changes included
module.exports = {
  publicPath: process.env.BASE_PATH || '/',
  lintOnSave: false,
  configureWebpack: (config) => {
    if (config.output.libraryTarget) {
      // hack to remove invalid demo.html output generated by 'demo-html' plugin.
      // see https://github.com/vuejs/vue-cli/issues/3291#issuecomment-646988930
      config.plugins.some((plugin, index) => {
        return plugin.options && plugin.options.filename === 'demo.html'
          ? config.plugins.splice(index, 1)
          : false
      })

      // mark these dependencies as being external, so they're not bundled up in the library
      const externals = [
        '@duetds/date-picker/dist/loader',
        'dayjs',
        'dayjs/plugin/customParseFormat',
        'lodash',
        'vue-router'
      ]

      return { externals }
    }
    return {}
  },
  chainWebpack: (config) => {
    const rule = config.module.rule('scss').test(/\.scss$/)
    addResourcesLoader(rule.oneOf('vue'))
    addResourcesLoader(rule.oneOf('normal'))
  }
}

const addResourcesLoader = (rule) => {
  rule
    .use('sass-resources-loader')
    .loader('sass-resources-loader')
    .tap(() => ({
      resources: [
        './src/assets/scss/variables.scss',
        './src/assets/scss/mixins.scss'
      ]
    }))
}
